# Prerequisites

MySQL 8.0+ / MariaDB 10+

# Install

## Create the database used

```shell
sudo mysql -u root < src/main/sql/create-database.sql
```

# Update Configuration

```shell
vim grails-app/conf/application.yml
```

## Replace DB Connection Params

While in vim, for
```yaml
dataSource:
  driverClassName:
```
replace `org.h2.Driver` to `com.mysql.cj.jdbc.Driver`

for
```yaml
dataSource:
  username:
```
replace `sa` to `gfb1`

for
```yaml
dataSource:
  password:
```
replace `''` to `gfb1`

## Replace DB URL

While in vim, for
```yaml
environments:
  development:
    dataSource:
      url:
```
replace `jdbc:h2:mem:devDb;LOCK_TIMEOUT=10000;DB_CLOSE_ON_EXIT=FALSE` with `jdbc:mysql://127.0.0.1:3306/GormFormulaBug`

for
```yaml
    test:
      dataSource:
        url:
```
replace `jdbc:h2:mem:testDb;LOCK_TIMEOUT=10000;DB_CLOSE_ON_EXIT=FALSE` with `jdbc:mysql://127.0.0.1:3306/GormFormulaBug`

for
```yaml
    production:
      dataSource:
        url:
```
replace `jdbc:h2:./prodDb;LOCK_TIMEOUT=10000;DB_CLOSE_ON_EXIT=FALSE` with `jdbc:mysql://127.0.0.1:3306/GormFormulaBug`

# Run the app to populate the schema

```shell
grails run-app
```

# Update Configuration to 'update'

```
vim grails-app/conf/application.yml
```

While in vim, for
```yaml
    environments:
      development:
        dataSource:
          dbCreate:
```
replace `create-drop` with `update`

# Re-run the app and see the log output

```shell
grails run-app
```

## Observations

In the log, notice `Child #1` having `null` for `bmi` while `Child #2` has `27.16`.

Also in the database schema, notice that `bad_parent` table has the `bmi` column created while `good_parent` table does not.

